// Export Layers As PSD Files
// version 0.2
// (c) vd
// ai-js@mail.ru

// BECAUSE THE SCRIPT IS DISTRIBUTED FREE OF CHARGE, THERE IS NO
// WARRANTY FOR THE SCRIPT, TO THE EXTENT PERMITTED BY APPLICABLE
// LAW. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE 
// SCRIPT IS WITH YOU. SHOULD THE SCRIPT PROVE DEFECTIVE, YOU 
// ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 


if ( documents.length > 0 )
{
	doc = activeDocument;

	var type = ExportType.PHOTOSHOP;
	var exportOptions = new ExportOptionsPhotoshop();
	doc.documentColorSpace == DocumentColorSpace.CMYK ? exportOptions.imageColorSpace = ImageColorSpace.CMYK : exportOptions.imageColorSpace = ImageColorSpace.RGB;
	exportOptions.writeLayers = false;

	// bounding
	var BG = doc.layers.add();
	BG.name = "Bounder";
	BG.zOrder(ZOrderMethod.SENDTOBACK);

	var x = doc.visibleBounds[0];
	var y = doc.visibleBounds[1];
	var w = doc.visibleBounds[2]-doc.visibleBounds[0];
	var h = doc.visibleBounds[1]-doc.visibleBounds[3];

	var iBG = BG.pathItems.rectangle(y,x,w,h);
	iBG.filled = true;
	iBG.stroked = false;
	iBG.opacity = 0;

	// hiding
	var vis = new Array();
	for(i=0;i<doc.layers.length-1;i++) {
		vis[i] = doc.layers[i].visible;
		doc.layers[i].visible = false;
	}

	// exporting
	lFolder = new Folder(doc.path + "/" + doc.name + " Layers");
	lFolder.create();

	for(i=0;i<doc.layers.length-1;i++) 
	if(vis[i]) {
		doc.layers[i].visible = true;
		fileSpec = new File( doc.path + "/" + doc.name + " Layers/" + doc.layers[i].name + ".psd" );
		doc.exportFile( fileSpec, type, exportOptions );
		doc.layers[i].visible = false;
	}

	// unhiding
	for(i=0;i<doc.layers.length-1;i++) {
		doc.layers[i].visible = vis[i];
	}

	//finishing
	BG.remove();
	redraw();
	alert("Done.\nCheck \"" + doc.name + " Layers" + "\" subfolder in folder your document placed.");

}